using System;
using System.Collections.Generic;
using System.Text;

namespace FF3LE
{
    public class StringManage
    {

        #region stringTable
        public string[] dialogueTable = new string[]
            {
                "/", "*", "TERRA", "LOCKE", "CYAN", "SHADOW", "EDGAR", "SABIN", 
                "CELES", "STRAGO", "RELM", "SETZER", "MOG", "GAU", "GOGO", "UMARO", 
                "", "", "", "*", "", "", "", "", 
                "", "", "", "", "", "", "", "", 
                "A", "B", "C", "D", "E", "F", "G", "H",
                "I", "J", "K", "L", "M", "N", "O", "P", 
                "Q", "R", "S", "T", "U", "V", "W", "X", 
                "Y", "Z", "a", "b", "c", "d", "e", "f", 
                "g", "h", "i", "j", "k", "l", "m", "n",
                "o", "p", "q", "r", "s", "t", "u", "v", 
                "w", "x", "y", "z", "0", "1", "2", "3",
                "4", "5", "6", "7", "8", "9", "!", "?", 
                "", ":", "\"", "'", "-", ".", ",", "...",
                ";", "#", "+", "(", ")", "%", "~", "", 
                "@", "<note>", "=", "\"", "74", "75", "<pearl>", "<death>",
                "<lit>", "<wind>", "<earth>", "<ice>", "<fire>", "<water>", "<poison>", " ", 
                "e ", " t", ": ", "th", "t ", "he", "s ", "er", 
                " a", "re", "in", "ou", "d ", " w", " s", "an", 
                "o ", " h", " o", "r ", "n ", "at", "to", " i",
                ", ", "ve", "ng", "ha", " m", "Th", "st", "on", 
                "yo", " b", "me", "y ", "en", "it", "ar", "ll",
                "ea", "I ", "ed", " f", " y", "hi", "is", "es", 
                "or", "l ", " c", "ne", "'s", "nd", "le", "se", 
                " I", "a ", "te", " l", "pe", "as", "ur", "u ", 
                "al", " p", "g ", "om", " d", "f ", " g", "ow",
                "rs", "be", "ro", "us", "ri", "wa", "we", "Wh", 
                "et", " r", "nt", "m ", "ma", "I'", "li", "ho",
                "of", "Yo", "h ", " n", "ee", "de", "so", "gh", 
                "ca", "ra", "n'", "ta", "ut", "el", "! ", "fo",
                "ti", "We", "lo", "e!", "ld", "no", "ac", "ce", 
                "k ", " u", "oo", "ke", "ay", "w ", "!!", "ag",
                "il", "ly", "co", ". ", "ch", "go", "ge", "e..."
            };
        public string[] nameTable = new string[]
            {
                "<EBhE؂ւ>\r\n","\r\n","è","ۯ","","޳","޶ް","ϯ",
                //"<EBhE؂ւ>\r\n","<s>\r\n","è","ۯ","","޳","޶ް","ϯ",
                @"ؽ","׺޽","","§","Ӹ","޳","޺","",

                "<Wait֘A1>","<I֘A?0x11>","<IR[h?0x12>","<Wait֘A2>","<R[h?0x14>","<I>",
                  "<Wait֘A3>","<gp0x17>","<R[h?0x18>","<gp0x19>","<gp0x1A>",
                @"<g1B>","<g1C>","<g1D>","<g1E>","<g1F>",

                "o","","r","","u","","x","","{","","K","","M","","O","",
                "Q","","S","","U","","W","","Y","","[","","]","","_","",
                "a","","d","","f","","h","","","p","","s","","v","","y",
                "","|","","O","P","Q","R","S","T","U","V","W","X","M","H","P",
                "n","","q","","t","","w","","z","","J","","L","","N","",
                "P","","R","","T","","V","","X","","Z","","\","","^","",
                "`","","c","","e","","g","","E","","A","","C","","G","",
                "I","","i","","j","","k","","l","","m","","}","","~","",
                "","","","","","","","","","","","","","","","",
                "","","","","","","","","","","","","b","","","",
                "","","","","@","[","B","c","D","!" ,"F","?" ,"H","A","/" ," :",

                "u","v","B","{","","","<I>","~","cc","鍑","","","b","Ȃ","","E",
                "Ă","޽ׁu","̶u","","","","݁u","","m","ł",
                @"ށu","̗","","B","B","l",
                "eBi","bN","JCG","VhE","GhK[","}bV","ZX","XgSX",
                @"","Zbc@[","O","KE","SS","E[}","<gp?0xFE>","@",
            };
        private string[] kanjiTable1B = new string[]
            {
                "","","","","","i","","R","","","","","","L","Z","",
                "","M","_","J","S","t","g","U","C","","","","l","n","U","D",
                "J","","v","","","","h","","P","","","","","","r","n",
                "~","","j","","","","","","","x","","","G","K","","U",
                "G","R","","]","","b","r","","k","","","A","","","","Q",
                "","","","@","D","","","","s","","T","5B","5C","5D","5E","5F",
                "60","61","62","63","64","65","66","67","68","69","6A","6B","6C","6D","6E","6F",
                "70","71","72","73","74","75","76","77","78","79","7A","7B","7C","7D","7E","7F",
                "80","81","82","83","84","85","86","87","88","89","8A","8B","8C","8D","8E","8F",
                "90","91","92","93","94","95","96","97","98","99","9A","9B","9C","9D","9E","9F",
                "A0","A1","A2","A3","A4","A5","A6","A7","A8","A9","AA","AB","AC","AD","AE","AF",
                "B0","B1","B2","B3","B4","B5","B6","B7","B8","B9","BA","BB","BC","BD","BE","BF",
                "C0","C1","C2","C3","C4","C5","C6","C7","C8","C9","CA","CB","CC","CD","CE","CF",
                "D0","D1","D2","D3","D4","D5","D6","D7","D8","D9","DA","DB","DC","DD","DE","DF",
                "E0","E1","E2","E3","E4","E5","E6","E7","E8","E9","EA","EB","EC","ED","EE","EF",
                "F0","F1","F2","F3","F4","F5","F6","F7","F8","F9","FA","FB","FC","FD","FE","FF",
            };
        private string[] kanjiTable1C = new string[]
            {
                "","","","","","","","q","","","t","","p","Q","","",
                "v","R","","m","","l","","b","","","","","","","V","",
                "","","{","","","","N","","","","","z","","x","","J",
                "","","","","","j","","","","","D","","","N","c","",
                "O","`","M","","","l","F","","@","k","A","","e","D","","",
                "N","","","","","","","","X","","","Z","","","Z","",
                "a","","","n","","","","","","M","","","","","^","",
                "","","y","a","R","","s","~","","v","","","","","","",
                "","]","","g","","","","","x","","","","K","t","","s",
                "","","","B","","","","","","I","","H","v","","","",
                "D","`","","","","","x","}","","","","","","i","","",
                "X","","R","","","t","","\","p","t","h","","v","","","",
                "I","","","","","","Y","","","","R","A","","","","",
                "","","","","","K","~","","I","","i","","","","","",
                "Y","","q","","V","","","","W","","","","","","","`",
                "","","","v","","W","N","","","","B","L","","L","","",
            };
        private string[] kanjiTable1D = new string[]
            {
                "","","b","","p","@","","","","Q","","","","t","","",
                "","","","G","","E","","","","D","","k","","","","",
                "","","\","y","","","i","","S","","p","[","","","","",
                "X","","","","","","","","","","","","","","","",
                "","","","","","","","i","","","Y","~","F","","","X",
                "w","","","u","","\","","p","","E","","\","","c","","S",
                "F","","","","","H","","","","B","","","i","o","","",
                "A","","","","","T","","q","","d","","","","u","|","",
                "c","","","","","S","","","","e","","","","","","",
                "","o","\","","","w","O","","h","P","","","","L","R","",
                "n","h","","q","","","","","p","d","t","L","","","","P",
                "","f","","","","","k","x","","","","","","","r","x",
                "","G","","c","","","","t","[","","","","@","[","l","S",
                "","","","","`","H","","","c","","","f","D","","_","",
                "","^","p","","","","","","A","","}","","","E","0x1dEE","0x1dEF",
                "X","","","L","","","","","","O","Q","m","","","",""
            };
        private string[] kanjiTable1E = new string[]
            {
                "h","","","z","s","","","","","","U","","","m","","g",
                "","","","","","","","","","","","o","","","","",
                "","F","g","l","","","","","","","","S","f","","","",
                "","E","P","","","","","","G","_","","|","","","","",
                "","","\","{","","","","","s","","","","","","","",
                "`","a","w","x","k","q","d","g","l","o","b","s","u","r","","",
                "","","","","","","","","m","","","","","","","",
                "","","","","","","J","n","Z","^","","","","v","","",
                "","","","e","~","","","","","","","","","","","",
                "","C","","","C","S","`","Z","","","","","","","","",
                "","","","","c","","K","","","","E","a","","","C","b",
                "","","","^","S","_","n","w","","","","","","","z","u",
                "","e","f","n","","","","V","]","{","","","g","j","e","",
                "","","","K","S","","","@","","P","","","","","","",
                "","d","","","","","","","","","","","","","T","0x1eEF",
                "","","","","o","","Y","","0x1eF8","0x1eF9","0x1eFA","0x1eFB","0x1eFC","0x1eFD","0x1eFE","0x1eFF",
            };
        private string[] kanjiTable1F = new string[]
            {
                "","K","","","","q","","","X","","K","","","","","",
                "","","","","H","","","","","","","","","","","",
                "o","","r","","u","","x","","{","","K","","M","","O","",
                "Q","","S","","U","","W","","Y","","[","","]","","_","",
                "a","","d","","f","","h","","","p","","s","","v","","",
                "","|","","0","1","2","3","4","5","6","7","8","9","m","h","p",
                "n","","q","","t","","w","","z","","J","","L","","N","",
                "P","","R","","T","","V","","X","","Z","","\","","^","",
                "`","","c","","e","","g","","E","","A","","C","","G","",
                "I","","i","","j","","k","","l","","m","","}","","~","",
                "","","","","","","","","","","","","","","","",
                "","","","","","","","","","","","","b","","","",
                "","","","","@","[","B","c","D","I","F","H","H","A","^","F",
                "u","v","B","\","o","","","","","","a","v","J","s","I","",
                "","","]","","","","","","j","]","","","","","","",
                "`","","","","","Y","","Y","","","","B","","O","","0x1fFF",
            };

        private string[] comandNameArray = new string[]
            {
        "","ACe","܂ق","gX","ǂ","ʂ","Ԃǂ","Ђ","Ȃ",
        "","Ђ킴","܂ӂ","ڂ킴","XPb`","","Xbg",
        "΂","Ƃт","̂܂","ǂ","`FW","ڂ","Wv","񂼂","ɂȂ",
        "傤","̂","VbN","Ƃ","܂ǂ","Ȃ"
            };

        #endregion
        #region stringFunction
        /// <summary>
        /// oCif[^̃ItZbgʒu當f[^쐬ԂBIR[h0x00ƂȂ
        /// </summary>
        /// <param name="data">f[^</param>
        /// <param name="offset">f[^ǂݏoJnʒu</param>
        /// <returns>ϊ㕶</returns>
        public string GetString(byte[] data, int offset)
        {
            string str = "";
            while (data[offset] != 0)
            {
                switch (data[offset])
                {
                    case 0x1b:
                        offset++;
                        str += kanjiTable1B[data[offset++]];
                        break;
                    case 0x1c:
                        offset++;
                        str += kanjiTable1C[data[offset++]];
                        break;
                    case 0x1d:
                        offset++;
                        str += kanjiTable1D[data[offset++]];
                        break;
                    case 0x1e:
                        offset++;
                        str += kanjiTable1E[data[offset++]];
                        break;
                    case 0x1f:
                        offset++;
                        str += kanjiTable1F[data[offset++]];
                        break;
                    default:
                        str += nameTable[data[offset++]];
                        break;
                }
            }
            return str;
        }

        /// <summary>
        /// ϒ̃oCif[^̃ItZbgʒu當f[^쐬ԂB
        /// </summary>
        /// <param name="data">f[^</param>
        /// <param name="offset">f[^ǂݏoJnʒu</param>
        /// <param name="length">ǂݏooCg̒</param>
        /// <returns>ϊ㕶</returns>
        public string GetString(byte[] data, int offset, int length)
        {
            string str = "";
            int endOffset = offset + length;
            while (offset < endOffset)
            {
                if (data[offset] == 0xFF) break;
                if (data[offset] == 0x00) break;
                switch (data[offset])
                {
                    case 0x1b:
                        offset++;
                        str += kanjiTable1B[data[offset++]];
                        break;
                    case 0x1c:
                        offset++;
                        str += kanjiTable1C[data[offset++]];
                        break;
                    case 0x1d:
                        offset++;
                        str += kanjiTable1D[data[offset++]];
                        break;
                    case 0x1e:
                        offset++;
                        str += kanjiTable1E[data[offset++]];
                        break;
                    case 0x1f:
                        offset++;
                        str += kanjiTable1F[data[offset++]];
                        break;
                    default:
                        str += nameTable[data[offset++]];
                        break;
                }
            }
            return str;
        }

        /// <summary>
        /// w肳ꂽŁA^ꂽoCif[^̃ItZbgʒu當f[^쐬ԂB
        /// </summary>
        /// <param name="data">f[^</param>
        /// <param name="offset">f[^ǂݏoJnʒu</param>
        /// <param name="length">ǂݏooCg̒</param>
        /// <returns>ϊ㕶</returns>
        public string GetStringFixed(byte[] data, int offset, int length)
        {
            string str = "";
            int endOffset = offset + length;
            while (offset < endOffset)
            {
                switch (data[offset])
                {
                    case 0x1b:
                        offset++;
                        str += kanjiTable1B[data[offset++]];
                        break;
                    case 0x1c:
                        offset++;
                        str += kanjiTable1C[data[offset++]];
                        break;
                    case 0x1d:
                        offset++;
                        str += kanjiTable1D[data[offset++]];
                        break;
                    case 0x1e:
                        offset++;
                        str += kanjiTable1E[data[offset++]];
                        break;
                    case 0x1f:
                        offset++;
                        str += kanjiTable1F[data[offset++]];
                        break;
                    default:
                        str += nameTable[data[offset++]];
                        break;
                }
            }
            return str;
        }

        /// <summary>
        /// w肵oCg܂Őݒ肷֐
        /// </summary>
        /// <param name="data">ݒ肷f[^</param>
        /// <param name="offset">f[^ݒ肷ꏊ</param>
        /// <param name="str">ݒ肵̕</param>
        /// <param name="length">ݒ肷oCg</param>
        /// <param name="voidData">w肵oCgɓBȂꍇɖ߂bytef[^</param>
        public void SetString(byte[] data, int offset, string str, int bytelength, byte voidData)
        {
            byte[] temp = new byte[bytelength * 4];
            int tempPointer = 0;
            int endOffset = offset + bytelength;
            bool serch;
            string tempStr;

            for (int i = 0; i < str.Length && tempPointer < bytelength; i++)
            {
                serch = true;
                tempStr = str.Substring(i, 1);
                if (serch) for (int j = 0; j < nameTable.Length; j++)
                        if (nameTable[j][0] == tempStr[0])
                        {
                            if (nameTable[j] == tempStr)
                            {
                                temp[tempPointer++] = (byte)j;
                                serch = false;
                                break;
                            }
                            else
                            {
                                if (str.IndexOf(nameTable[j]) == i)
                                {
                                    temp[tempPointer++] = (byte)j;
                                    serch = false;
                                    i += nameTable[j].Length - 1;
                                    break;
                                }
                            }

                        }
                if (serch) for (int j = 0; j < kanjiTable1F.Length; j++)
                        if (kanjiTable1F[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1F;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1E.Length; j++)
                        if (kanjiTable1E[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1E;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1D.Length; j++)
                        if (kanjiTable1D[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1D;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1C.Length; j++)
                        if (kanjiTable1C[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1C;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1B.Length; j++)
                        if (kanjiTable1B[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1B;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }

            }
            while (tempPointer < bytelength) temp[tempPointer++] = voidData;
            Array.Copy(temp, 0, data, offset, bytelength);
        }

        /// <summary>
        /// R̕؂oCg܂Őݒ肷֐
        /// ŏIbyteɂ͕K1ȏvoidf[^ݒ肷
        /// </summary>
        /// <param name="data">Ώۃf[^</param>
        /// <param name="offset">ItZbgʒu</param>
        /// <param name="str">ݒ蕶</param>
        /// <param name="paddingLength">؂oCg</param>
        /// <param name="voidData">؂܂ł𖄂߂oCgf[^</param>
        /// <returns>ݒ肵oCg</returns>
        public int SetStringPadding(byte[] data, int offset, string str, int paddingLength, byte voidData)
        {
            byte[] temp = new byte[str.Length * 3 + 10];
            int tempPointer = 0;
            bool serch;
            string tempStr;
            int i;
            for (i = 0; i < str.Length; i++)
            {
                serch = true;
                tempStr = str.Substring(i, 1);
                if (serch) for (int j = 0; j < nameTable.Length; j++)
                        if (nameTable[j][0] == tempStr[0])
                        {
                            if (nameTable[j] == tempStr)
                            {
                                temp[tempPointer++] = (byte)j;
                                serch = false;
                                break;
                            }
                            else
                            {
                                if (str.IndexOf(nameTable[j]) == i)
                                {
                                    temp[tempPointer++] = (byte)j;
                                    serch = false;
                                    i += nameTable[j].Length - 1;
                                    break;
                                }
                            }

                        }
                if (serch) for (int j = 0; j < kanjiTable1F.Length; j++)
                        if (kanjiTable1F[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1F;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1E.Length; j++)
                        if (kanjiTable1E[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1E;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1D.Length; j++)
                        if (kanjiTable1D[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1D;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1C.Length; j++)
                        if (kanjiTable1C[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1C;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1B.Length; j++)
                        if (kanjiTable1B[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1B;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
            }
            do temp[tempPointer++] = voidData; while (tempPointer % paddingLength != 0x00);
            Array.Copy(temp, 0, data, offset, tempPointer);
            return tempPointer;
        }

        /// <summary>
        /// R̕ŏIbyteɂvoidf[^ݒ肷
        /// </summary>
        /// <param name="data">Ώۃf[^</param>
        /// <param name="offset">ItZbgʒu</param>
        /// <param name="str">ݒ蕶</param>
        /// <param name="voidData">ŏIoCgf[^</param>
        /// <returns>ݒ肵oCg</returns>
        public int SetString(byte[] data, int offset, string str, byte voidData)
        {
            byte[] temp = new byte[str.Length * 3 + 10];
            int tempPointer = 0;
            bool serch;
            string tempStr;
            int i;
            for (i = 0; i < str.Length; i++)
            {
                serch = true;
                tempStr = str.Substring(i, 1);
                if (serch) for (int j = 0; j < nameTable.Length; j++)
                        if (nameTable[j][0] == tempStr[0])
                        {
                            if (nameTable[j] == tempStr)
                            {
                                temp[tempPointer++] = (byte)j;
                                serch = false;
                                break;
                            }
                            else
                            {
                                if (str.IndexOf(nameTable[j]) == i)
                                {
                                    temp[tempPointer++] = (byte)j;
                                    serch = false;
                                    i += nameTable[j].Length - 1;
                                    break;
                                }
                            }

                        }
                if (serch) for (int j = 0; j < kanjiTable1F.Length; j++)
                        if (kanjiTable1F[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1F;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1E.Length; j++)
                        if (kanjiTable1E[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1E;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1D.Length; j++)
                        if (kanjiTable1D[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1D;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1C.Length; j++)
                        if (kanjiTable1C[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1C;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1B.Length; j++)
                        if (kanjiTable1B[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1B;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
            }
            temp[tempPointer++] = voidData;
            Array.Copy(temp, 0, data, offset, tempPointer);
            return tempPointer;
        }

        #endregion


    }
}
